local SAYKARMA_CURRENT_VERSION = GetAddOnMetadata("SayKarma", "Version"); -- get the version from the toc file (tag: #Version)
local SAYKARMA_DESCRIPTION = GetAddOnMetadata("SayKarma", "Notes"); -- get the description from the toc file (tag: #Notes)
local SayKarmaCommand = CreateFrame("Frame");

SayKarmaCommand:RegisterEvent("ADDON_LOADED");

-- Slash commands
SLASH_SAYKARMACMD1 = '/sk';
SLASH_SAYKARMACMD2 = '/saykarma';

-- Slash command: arguments dectection
function SlashCmdList.SAYKARMACMD(msg, editbox)
    -- Since there is a sensitive case detection, we put our slash commands and arguments to lowercase 
    if (msg ~= nil) then
        msg = string.lower(msg);
    end

    -- show the basic-commands
    if (msg == "help") then
        print("/sk help --------------------------------------------------");
        print("/sk ui: Brings up the window settings");
        print("/sk version: show the version on this addon");
        print("/sk description: show the description on this addon");
        print("/sk isEnable: check if the addon is enable or not");
        print("/sk reset yes: reset SayKarma");
        print("/sk enable/on/disable/off: turn on/off SayKarma");
        print("/sk disable: turn off SayKarma");
        print("/sk legacy: get back to the old SayKarma. Say arround you that you\'ve been touched by \"Touch of Karma\" and nothing else");
        print("/sk default: get back to the default settings");
        print("/sk list: show you some extra commands");
        print("-------------------------------------------------- /sk help");

        -- show some extra-commands

    elseif (msg == "list") then
        print("/sk list --------------------------------------------------");
        print("/sk dk/deathnight enable/disable: turn on/off Death knight detection");
        print("/sk druid/drood enable/disable: turn on/off Druid detection");
        print("/sk hunter/hunt enable/disable: turn on/off Hunt detection");
        print("/sk mage enable/disable: turn on/off mage detection");
        print("/sk monk/yoda enable/disable: turn on/off Monk detection");
        print("/sk paladin enable/disable: turn on/off Paladin detection");
        print("/sk priest enable/disable: turn on/off Priest detection");
        print("/sk rogue/rouge enable/disable: turn on/off Rogue detection");
        print("/sk shaman/sham enable/disable: turn on/off Shaman detection");
        print("/sk warlock/lock enable/disable: turn on/off Warlock detection");
        print("/sk warrior/war enable/disable: turn on/off Warrior detection");
        print("-------------------------------------------------- /sk list");

    elseif (msg == "ui") then
        InterfaceOptionsFrame_OpenToCategory(SayKarmaSettings.panel);
        
        -- do it a second time, since the first time it won't open the good panel (weird...)
        InterfaceOptionsFrame_OpenToCategory(SayKarmaSettings.panel);

        -- Show the version on this addon
    elseif (msg == "version") then
        print("SayKarma version: " .. SAYKARMA_CURRENT_VERSION);

        -- Show the description on this addon	
    elseif (msg == "description") then
        print("SayKarma\'s description :" .. SAYKARMA_DESCRIPTION);

        -- check if the addon is enable or not
    elseif (msg == "isEnable") or (msg == "isenable") then -- I know, isEnable is useless since I use string.lower() but I prefer to have a camel case 
        print("Is SayKarma enable ?: " .. SayKarmaPrefs['SayKarmaEnable']);

        -- enable/disable SayKarma
    elseif (msg == "enable") or (msg == "on") then
        SayKarmaFunctionEnable();
    elseif (msg == "disable") or (msg == "off") then
        SayKarmaFunctionDisable();

        -- set SayKarma to the old school version or get back the new way
    elseif (msg == "legacy") then
        SayKarmaFunctionLegacy();

        -- set SayKarma with the default settings
    elseif (msg == "default") then
        SayKarmaDefaultLoadingPrefsEnable();

        -- Reset SayKarma,
    elseif (msg == "reset yes") then
        SayKarmaResetYes();

        -- turn on/off Death knight detection	
    elseif (msg == "deathnight enable") or (msg == "dk enable") then
        SayKarmaFunctionDeathKnightEnable();
    elseif (msg == "deathnight disable") or (msg == "dk disable") then
        SayKarmaFunctionDeathKnightDisable();

        -- turn on/off Druid detection
    elseif (msg == "druid enable") or (msg == "drood enable") then
        SayKarmaFunctionDruidEnable();
    elseif (msg == "druid disable") or (msg == "drood disable") then	
        SayKarmaFunctionDruidDisable();

        -- turn on/off Hunt detection
    elseif (msg == "hunter enable") or (msg == "hunt enable") then
        SayKarmaFunctionHunterEnable();
    elseif (msg == "hunter disable") or (msg == "hunt disable") then
        SayKarmaFunctionHunterDisable();

        -- turn on/off mage detection
    elseif (msg == "mage enable") then
        SayKarmaFunctionMageEnable();
    elseif (msg == "mage disable") then
        SayKarmaFunctionMageDisable();

        -- turn on/off monk detection
    elseif (msg == "monk enable") or (msg == "yoda enable")then
        SayKarmaFunctionMonkEnable();
    elseif (msg == "monk disable") or (msg == "yoda disable") then	
        SayKarmaFunctionMonkDisable();

        -- turn on/off paladin detection
    elseif (msg == "paladin enable") then
        SayKarmaFunctionPaladinEnable();
    elseif (msg == "paladin disable") then
        SayKarmaFunctionPaladinDisable();

        -- turn on/off priest detection
    elseif (msg == "priest enable") then
        SayKarmaFunctionPriestEnable();
    elseif (msg == "priest disable") then
        SayKarmaFunctionPriestDisable();

        -- turn on/off priest detection
    elseif (msg == "rogue enable") or (msg == "rouge enable") then
        SayKarmaFunctionRogueEnable();
    elseif (msg == "rogue disable") or (msg == "rouge disable") then
        SayKarmaFunctionRogueDisable();

        -- turn on/off shaman detection
    elseif (msg == "shaman enable") or (msg == "sham enable") then
        SayKarmaFunctionShamanEnable();
    elseif (msg == "shaman disable") or (msg == "sham disable") then
        SayKarmaFunctionShamanDisable();

        -- turn on/off warlock detection
    elseif (msg == "warlock enable") or (msg == "lock enable") then
        SayKarmaFunctionWarlockEnable();
    elseif (msg == "warlock disable") or (msg == "lock disable") then
        SayKarmaFunctionWarlockDisable();

        -- turn on/off warrior detection
    elseif (msg == "warrior enable") or (msg == "war enable") then
        SayKarmaFunctionWarriorEnable();
    elseif (msg == "warrior disable") or (msg == "war disable") then
        SayKarmaFunctionWarriorDisable();

    else
        -- if the user use "/sk"
        print("use /sk help for more help");
    end
end

-- Enable addon, only the detection is enabled 
function SayKarmaFunctionEnable()
    SayKarmaPrefs['SayKarmaEnable'] = "yes";
    print("SayKarma enabled");
end

-- Disable addonn only the detection is disabled
function SayKarmaFunctionDisable()
    SayKarmaPrefs['SayKarmaEnable'] = "no";
    print("SayKarma disabled");
end

-- Enable DeathKnight section
function SayKarmaFunctionDeathKnightEnable()
    SayKarmaPrefs['DeathKnightEnable'] = "yes";
    print("SayKarma: DeathKnight enabled");
end

-- Disable DeathKnight section
function SayKarmaFunctionDeathKnightDisable()
    SayKarmaPrefs['DeathKnightEnable'] = "no";
    print("SayKarma: DeathKnight disable");
end

-- Enable druid section
function SayKarmaFunctionDruidEnable()
    SayKarmaPrefs['DruidEnable'] = "yes";
    print("SayKarma: Druid enabled");
end

-- Disable druid section
function SayKarmaFunctionDruidDisable()
    SayKarmaPrefs['DruidEnable'] = "no";
    print("SayKarma: Druid disable");
end

-- Enable hunter section
function SayKarmaFunctionHunterEnable()
    SayKarmaPrefs['HunterEnable'] = "yes";
    print("SayKarma: Hunter enabled");
end

-- Disable hunter section
function SayKarmaFunctionHunterDisable()
    SayKarmaPrefs['HunterEnable'] = "no";
    print("SayKarma: Hunter disable");
end

-- Enable mage section
function SayKarmaFunctionMageEnable()
    SayKarmaPrefs['MageEnable'] = "yes";
    print("SayKarma: Mage enabled");
end

-- Disable mage section
function SayKarmaFunctionMageDisable()
    SayKarmaPrefs['MageEnable'] = "no";
    print("SayKarma: Mage disable");
end

-- Enable monk section
function SayKarmaFunctionMonkEnable()
    SayKarmaPrefs['MonkEnable'] = "yes";
    print("SayKarma: Monk enabled");
end

-- Disable monk section
function SayKarmaFunctionMonkDisable()
    SayKarmaPrefs['MonkEnable'] = "no";
    print("SayKarma: Monk disable");
end

-- Enable paladin section
function SayKarmaFunctionPaladinEnable()
    SayKarmaPrefs['PaladinEnable'] = "yes";
    print("SayKarma: Paladin enabled");
end

-- Disable paladin section
function SayKarmaFunctionPaladinDisable()
    SayKarmaPrefs['PaladinEnable'] = "no";
    print("SayKarma: Paladin disable");
end

-- Enable priest section
function SayKarmaFunctionPriestEnable()
    SayKarmaPrefs['PriestEnable'] = "yes";
    print("SayKarma: Priest enabled");
end

-- Disable priest section
function SayKarmaFunctionPriestDisable()
    SayKarmaPrefs['PriestEnable'] = "no";
    print("SayKarma: Priest disable");
end

-- Enable rogue section
function SayKarmaFunctionRogueEnable()
    SayKarmaPrefs['RogueEnable'] = "yes";
    print("SayKarma: Rogue enabled");
end

-- Disable rogue section
function SayKarmaFunctionRogueDisable()
    SayKarmaPrefs['RogueEnable'] = "no";
    print("SayKarma: Rogue disable");
end

-- Enable shaman section
function SayKarmaFunctionShamanEnable()
    SayKarmaPrefs['ShamanEnable'] = "yes";
    print("SayKarma: Shaman enabled");
end

-- Disable shaman section
function SayKarmaFunctionShamanDisable()
    SayKarmaPrefs['ShamanEnable'] = "no";
    print("SayKarma: Shaman disable");
end

-- Enable warlock section
function SayKarmaFunctionWarlockEnable()
    SayKarmaPrefs['WarlockEnable'] = "yes";
    print("SayKarma: Warlock enabled");
end

-- Disable warlock section
function SayKarmaFunctionWarlockDisable()
    SayKarmaPrefs['WarlockEnable'] = "no";
    print("SayKarma: Warlock disable");
end

-- Enable warrior section
function SayKarmaFunctionWarriorEnable()
    SayKarmaPrefs['WarriorEnable'] = "yes";
    print("SayKarma: Warrior enabled");
end

-- Disable warrior section
function SayKarmaFunctionWarriorDisable()
    SayKarmaPrefs['WarriorEnable'] = "no";
    print("SayKarma: Warrior disable");
end

-- Reset SayKarma, everything has to be reset
function SayKarmaResetYes()
    print("SayKarma: reset in progress");
    SAYKARMA_VERSION = nil;
    SayKarmaPrefs = nil;

    SAYKARMA_VERSION = SAYKARMA_CURRENT_VERSION;
    print("SayKarma: loading default values");
    SayKarmaDefaultLoadingPrefsEnable();
    print("SayKarma reseted");
end

-- Set SayKarma to the old SayKarma, meaning, say arround you only if you were touched bye "Touch of Karma" and nothing else
function SayKarmaFunctionLegacy()
    -- we disable everything
    SayKarmaDefaultLoadingPrefsDisable();

    -- we enable only what we need
    SayKarmaPrefs['SayKarmaEnable'] = "yes";
    SayKarmaPrefs['DecorationEnable'] = "yes";
    SayKarmaPrefs['WhichDecoration'] = "Skull";
    SayKarmaPrefs['MonkEnable'] = "yes";
    SayKarmaPrefs['MonkTouchOfKarma'] = "yes";
    
    print("SayKarma \"Legacy\" mode avativated");
end

-- Loading
function SayKarmaCommand:OnEvent(event, arg1)
    -- when the addon is loaded
    if (event == "ADDON_LOADED" and arg1 == "SayKarma") then
        -- initialization
        if (SAYKARMA_VERSION == nil) then
            SAYKARMA_VERSION = SAYKARMA_CURRENT_VERSION;
        end

        if (SayKarmaPrefs == nil) then
            print("Initialization");
            SayKarmaDefaultLoadingPrefsEnable();
        end
        -- initialization over

        -- is the user had an old version ? check if we have to update some old variables
        if (SAYKARMA_VERSION ~= SAYKARMA_CURRENT_VERSION) then
            -- we clean everything
            print("Updating saved variables...");
            SayKarmaFunctionUpdateSavedVariables();
            print("Updating terminated");
        end

        -- just a simple text to make the user aware that everything is loaded and and how to use the addon
        print("SayKarma Loaded - use /sk help for more help");

    end -- ((event == "ADDON_LOADED")
end -- function SayKarmaCommand:OnEvent


-- Allow to update some saved variables Just in case
function SayKarmaFunctionUpdateSavedVariables()
    SAYKARMA_VERSION = SAYKARMA_CURRENT_VERSION;
    SayKarmaPrefs = nil;	-- reset

    -- get back with the default settings
    SayKarmaDefaultLoadingPrefsEnable();
end

-- put SayKarma with the default mode, everything is enabled
function SayKarmaDefaultLoadingPrefsEnable()
    -- let's go to enable everything
    -- I know ! I could use some booleans instead of string variables with "yes"/"no"
    -- But I don't like Booleans, besides, I do what I want 
    SayKarmaPrefs = {		-- turn on all prefs
        ['SayKarmaEnable'] = "yes",
        ['DecorationEnable'] = "yes",
        ['WhichDecoration'] = "Skull",
        ['DeathKnightEnable'] = "yes",
        ['DruidEnable'] = "yes",
        ['HunterEnable'] = "yes",
        ['MageEnable'] = "yes",
        ['MonkEnable'] = "yes",
        ['PaladinEnable'] = "yes",
        ['PriestEnable'] = "yes",
        ['RogueEnable'] = "yes",
        ['ShamanEnable'] = "yes",
        ['WarlockEnable'] = "yes",
        ['WarriorEnable'] = "yes",
        ['DeathKnightAsphyxiate'] = "yes",
        ['DeathKnightMindFreeze'] = "yes",
        ['DeathKnightStrangulate'] = "yes",
        ['DruidCyclone'] = "yes",
        ['HunterCounterShot'] = "yes",
        ['HunterFreezingtrap'] = "yes",
        ['MageCounterspell'] = "yes",
        ['MagePolymorphCat'] = "yes",
        ['MagePolymorphPolarBearCub'] = "yes",
        ['MagePolymorphPig'] = "yes",
        ['MagePolymorphRabbit'] = "yes",
        ['MagePolymorphSheep'] = "yes",
        ['MonkLegSweep'] = "yes",
        ['MonkParalysis'] = "yes",
        ['MonkSpearHandStrike'] = "yes",
        ['MonkTouchOfKarma'] = "yes",
        ['PaladinFistOfJustice'] = "yes",
        ['PaladinHammerOfJustice'] = "yes",
        ['PaladinRebuke'] = "yes",
        ['PaladinRepentance'] = "yes",
        ['PriestDominateMind'] = "yes",
        ['PriestHolyWordChastise'] = "yes",
        ['PriestPsychicHorror'] = "yes",
        ['PriestSilence'] = "yes",
        ['RogueBlind'] = "yes",
        ['RogueGarrote'] = "yes",
        ['Roguekick'] = "yes",
        ['RogueSap'] = "yes",
        ['ShamanHex'] = "yes",
        ['ShamanWindShear'] = "yes",
        ['WarlockMesmerize'] = "yes",
        ['WarlockSeduction'] = "yes",
        ['WarriorDragonRoar'] = 'yes',
        ['WarriorPummel'] = "yes",
        ['WarriorShockwave'] = "yes",
        ['WarriorStormBolt'] = "yes",
        ['WarriorStormBoltOffHand'] = "yes",
    };
    
    print("SayKarma \"Default\" mode avativated");
end

-- turn off SayKarma, everything is disabled
function SayKarmaDefaultLoadingPrefsDisable()
    -- let's go to disable everything
    SayKarmaPrefs = {			-- turn off all prefs
        ['SayKarmaEnable'] = "no",
        ['DecorationEnable'] = "no",
        ['WhichDecoration'] = "Skull",
        ['DeathKnightEnable'] = "no",
        ['DruidEnable'] = "no",
        ['HunterEnable'] = "no",
        ['MageEnable'] = "no",
        ['MonkEnable'] = "no",
        ['PaladinEnable'] = "no",
        ['PriestEnable'] = "no",
        ['RogueEnable'] = "no",
        ['ShamanEnable'] = "no",
        ['WarlockEnable'] = "no",
        ['WarriorEnable'] = "no",
        ['DeathKnightAsphyxiate'] = "no",
        ['DeathKnightMindFreeze'] = "no",
        ['DeathKnightStrangulate'] = "no",
        ['DruidCyclone'] = "no",
        ['HunterCounterShot'] = "no",
        ['HunterFreezingtrap'] = "no",
        ['MageCounterspell'] = "no",
        ['MagePolymorphCat'] = "no",
        ['MagePolymorphPolarBearCub'] = "no",
        ['MagePolymorphPig'] = "no",
        ['MagePolymorphRabbit'] = "no",
        ['MagePolymorphSheep'] = "no",
        ['MonkLegSweep'] = "no",
        ['MonkParalysis'] = "no",
        ['MonkSpearHandStrike'] = "no",
        ['MonkTouchOfKarma'] = "no",
        ['PaladinFistOfJustice'] = "no",
        ['PaladinHammerOfJustice'] = "no",
        ['PaladinRebuke'] = "no",
        ['PaladinRepentance'] = "no",
        ['PriestDominateMind'] = "no",
        ['PriestHolyWordChastise'] = "no",
        ['PriestPsychicHorror'] = "no",
        ['PriestSilence'] = "no",
        ['RogueBlind'] = "no",
        ['RogueGarrote'] = "no",
        ['Roguekick'] = "no",
        ['RogueSap'] = "no",
        ['ShamanHex'] = "no",
        ['ShamanWindShear'] = "no",
        ['WarlockMesmerize'] = "no",
        ['WarlockSeduction'] = "no",
        ['WarriorDragonRoar'] = 'no',
        ['WarriorPummel'] = "no",
        ['WarriorShockwave'] = "no",
        ['WarriorStormBolt'] = "no",
        ['WarriorStormBoltOffHand'] = "no",
    };
end

SayKarmaCommand:SetScript("OnEvent", SayKarmaCommand.OnEvent);
