SayKarmaSettings = {};

-- =====================================================

-- Make a parent panel
-- Register in the Interface Addon Options GUI
SayKarmaSettings.panel = CreateFrame( "Frame", "SayKarmaOptionPanel", UIParent );

-- Set the name for the Category for the Options Panel
SayKarmaSettings.panel.name = "SayKarma";

-- Contents MainPanel
local title = SayKarmaSettings.panel:CreateFontString(nil, "ARTWORK", "GameFontNormalLarge");
title:SetText(format("%s", "SayKarma"));
title:SetPoint("CENTER", SayKarmaSettings.panel, "CENTER", 0, 170)

local version = SayKarmaSettings.panel:CreateFontString(nil, "ARTWORK", "GameFontNormalLarge");
version:SetText(format("%s: %s", "Version", GetAddOnMetadata("SayKarma", "Version")));
version:SetPoint("CENTER", SayKarmaSettings.panel, "CENTER", 0, 130)

local authors = SayKarmaSettings.panel:CreateFontString(nil, "ARTWORK", "GameFontNormalLarge");
authors:SetText(format("%s: %s & %s", "Authors", "Niska", "Eshria"));
authors:SetPoint("CENTER", SayKarmaSettings.panel, "CENTER", 0, 100)
-- End Contents MainPanel

-- Add the panel to the Interface Options
InterfaceOptions_AddCategory(SayKarmaSettings.panel);

-- =====================================================
-- OPTIONS PANEL

-- Make a child panel
SayKarmaSettings.childpanel1 = CreateFrame( "Frame", "SayKarmaOptionPanelChild", SayKarmaSettings.panel);

-- Set the name for the Category for the child Panel
SayKarmaSettings.childpanel1.name = "Options";

-- Specify childness of this panel (this puts it under the little red [+], instead of giving it a normal AddOn category)
SayKarmaSettings.childpanel1.parent = SayKarmaSettings.panel.name;

-- Contents MainPanel ==============================

-- CheckButton enable SayKarma
btnSayKarmaSettingsEnableAddon = CreateFrame("CheckButton", "btnSayKarmaSettingsEnableAddon_GlobalName", SayKarmaSettings.childpanel1, "ChatConfigCheckButtonTemplate");

-- text
btnSayKarmaSettingsEnableAddon_GlobalNameText:SetText("Enable SayKarma");

-- position
btnSayKarmaSettingsEnableAddon:SetPoint("TOPLEFT", 20, -20);

-- tooltip, mouseOver
btnSayKarmaSettingsEnableAddon.tooltip = "Enable or disable SayKarma";

-- checkButton clicked
btnSayKarmaSettingsEnableAddon:SetScript("OnClick", 
  function()
    if (SayKarmaPrefs['SayKarmaEnable'] == "yes") then
        SayKarmaFunctionDisable();
    else
        SayKarmaFunctionEnable();
    end
  end
);

-- init position button (true/false)
btnSayKarmaSettingsEnableAddon:SetScript("OnShow", function(frame)
        if (SayKarmaPrefs['SayKarmaEnable'] == "yes") then
            frame:SetChecked(true);
        else
            frame:SetChecked(false);
        end
    end)
-- End CheckButton enable SayKarma

-- =====

-- CheckButton enable DeathKnigh
btnSayKarmaDeathKnightEnable = CreateFrame("CheckButton", "btnSayKarmaDeathKnightEnable_GlobalName", SayKarmaSettings.childpanel1, "ChatConfigCheckButtonTemplate");

-- text
btnSayKarmaDeathKnightEnable_GlobalNameText:SetText("Enable DeathKnight detection");

-- position
btnSayKarmaDeathKnightEnable:SetPoint("TOPLEFT", 20, -200);

-- tooltip, mouseOver
btnSayKarmaDeathKnightEnable.tooltip = "Enable or disable spells\' detection from DeathKnight";

-- checkButton clicked
btnSayKarmaDeathKnightEnable:SetScript("OnClick", 
  function()
    if (SayKarmaPrefs['DeathKnightEnable'] == "yes") then
        SayKarmaFunctionDeathKnightDisable();
    else
        SayKarmaFunctionDeathKnightEnable();
    end
  end
);

-- init position button (true/false)
btnSayKarmaDeathKnightEnable:SetScript("OnShow", function(frame)
        if (SayKarmaPrefs['DeathKnightEnable'] == "yes") then
            frame:SetChecked(true);
        else
            frame:SetChecked(false);
        end
    end)
-- End CheckButton enable DeathKnight

-- =====

-- CheckButton enable Druid
btnSayKarmaDruidEnable = CreateFrame("CheckButton", "btnSayKarmaDruidEnable_GlobalName", SayKarmaSettings.childpanel1, "ChatConfigCheckButtonTemplate");

-- text
btnSayKarmaDruidEnable_GlobalNameText:SetText("Enable Druid detection");

-- position
btnSayKarmaDruidEnable:SetPoint("TOPLEFT", 20, -225);

-- tooltip, mouseOver
btnSayKarmaDruidEnable.tooltip = "Enable or disable spells\' detection from Druid";

-- checkButton clicked
btnSayKarmaDruidEnable:SetScript("OnClick", 
  function()
    if (SayKarmaPrefs['DruidEnable'] == "yes") then
        SayKarmaFunctionDruidDisable();
    else
        SayKarmaFunctionDruidEnable();
    end
  end
);

-- init position button (true/false)
btnSayKarmaDruidEnable:SetScript("OnShow", function(frame)
        if (SayKarmaPrefs['DruidEnable'] == "yes") then
            frame:SetChecked(true);
        else
            frame:SetChecked(false);
        end
    end)
-- End CheckButton enable Druid

-- =====

-- CheckButton enable Hunter
btnSayKarmaHunterEnable = CreateFrame("CheckButton", "btnSayKarmaHunterEnable_GlobalName", SayKarmaSettings.childpanel1, "ChatConfigCheckButtonTemplate");

-- text
btnSayKarmaHunterEnable_GlobalNameText:SetText("Enable Hunter detection");

-- position
btnSayKarmaHunterEnable:SetPoint("TOPLEFT", 20, -250);

-- tooltip, mouseOver
btnSayKarmaHunterEnable.tooltip = "Enable or disable spells\' detection from Hunter";

-- checkButton clicked
btnSayKarmaHunterEnable:SetScript("OnClick", 
  function()
    if (SayKarmaPrefs['HunterEnable'] == "yes") then
        SayKarmaFunctionHunterDisable();
    else
        SayKarmaFunctionHunterEnable();
    end
  end
);

-- init position button (true/false)
btnSayKarmaHunterEnable:SetScript("OnShow", function(frame)
        if (SayKarmaPrefs['HunterEnable'] == "yes") then
            frame:SetChecked(true);
        else
            frame:SetChecked(false);
        end
    end)
-- End CheckButton enable Hunter

-- =====

-- CheckButton enable Mage
btnSayKarmaMageEnable = CreateFrame("CheckButton", "btnSayKarmaMageEnable_GlobalName", SayKarmaSettings.childpanel1, "ChatConfigCheckButtonTemplate");

-- text
btnSayKarmaMageEnable_GlobalNameText:SetText("Enable Mage detection");

-- position
btnSayKarmaMageEnable:SetPoint("TOPLEFT", 20, -275);

-- tooltip, mouseOver
btnSayKarmaMageEnable.tooltip = "Enable or disable spells\' detection from Mage";

-- checkButton clicked
btnSayKarmaMageEnable:SetScript("OnClick", 
  function()
    if (SayKarmaPrefs['MageEnable'] == "yes") then
        SayKarmaFunctionMageDisable();
    else
        SayKarmaFunctionMageEnable();
    end
  end
);

-- init position button (true/false)
btnSayKarmaMageEnable:SetScript("OnShow", function(frame)
        if (SayKarmaPrefs['MageEnable'] == "yes") then
            frame:SetChecked(true);
        else
            frame:SetChecked(false);
        end
    end)
-- End CheckButton enable Mage

-- =====

-- CheckButton enable Monk
btnSayKarmaMonkEnable = CreateFrame("CheckButton", "btnSayKarmaMonkEnable_GlobalName", SayKarmaSettings.childpanel1, "ChatConfigCheckButtonTemplate");

-- text
btnSayKarmaMonkEnable_GlobalNameText:SetText("Enable Monk detection");

-- position
btnSayKarmaMonkEnable:SetPoint("TOPLEFT", 20, -300);

-- tooltip, mouseOver
btnSayKarmaMonkEnable.tooltip = "Enable or disable spells\' detection from Monk";

-- checkButton clicked
btnSayKarmaMonkEnable:SetScript("OnClick", 
  function()
    if (SayKarmaPrefs['MonkEnable'] == "yes") then
        SayKarmaFunctionMonkDisable();
    else
        SayKarmaFunctionMonkEnable();
    end
  end
);

-- init position button (true/false)
btnSayKarmaMonkEnable:SetScript("OnShow", function(frame)
        if (SayKarmaPrefs['MonkEnable'] == "yes") then
            frame:SetChecked(true);
        else
            frame:SetChecked(false);
        end
    end)
-- End CheckButton enable Monk

-- =====

-- CheckButton enable Paladin
btnSayKarmaPaladinEnable = CreateFrame("CheckButton", "btnSayKarmaPaladinEnable_GlobalName", SayKarmaSettings.childpanel1, "ChatConfigCheckButtonTemplate");

-- text
btnSayKarmaPaladinEnable_GlobalNameText:SetText("Enable Paladin detection");

-- position
btnSayKarmaPaladinEnable:SetPoint("TOPLEFT", 20, -325);

-- tooltip, mouseOver
btnSayKarmaPaladinEnable.tooltip = "Enable or disable spells\' detection from Paladin";

-- checkButton clicked
btnSayKarmaPaladinEnable:SetScript("OnClick", 
  function()
    if (SayKarmaPrefs['PaladinEnable'] == "yes") then
        SayKarmaFunctionPaladinDisable();
    else
        SayKarmaFunctionPaladinEnable();
    end
  end
);

-- init position button (true/false)
btnSayKarmaPaladinEnable:SetScript("OnShow", function(frame)
        if (SayKarmaPrefs['PaladinEnable'] == "yes") then
            frame:SetChecked(true);
        else
            frame:SetChecked(false);
        end
    end)
-- End CheckButton enable Paladin

-- =====

-- CheckButton enable Priest
btnSayKarmaPriestEnable = CreateFrame("CheckButton", "btnSayKarmaPriestEnable_GlobalName", SayKarmaSettings.childpanel1, "ChatConfigCheckButtonTemplate");

-- text
btnSayKarmaPriestEnable_GlobalNameText:SetText("Enable Priest detection");

-- position
btnSayKarmaPriestEnable:SetPoint("TOPLEFT", 20, -350);

-- tooltip, mouseOver
btnSayKarmaPriestEnable.tooltip = "Enable or disable spells\' detection from Priest";

-- checkButton clicked
btnSayKarmaPriestEnable:SetScript("OnClick", 
  function()
    if (SayKarmaPrefs['PriestEnable'] == "yes") then
        SayKarmaFunctionPriestDisable();
    else
        SayKarmaFunctionPriestEnable();
    end
  end
);

-- init position button (true/false)
btnSayKarmaPriestEnable:SetScript("OnShow", function(frame)
        if (SayKarmaPrefs['PriestEnable'] == "yes") then
            frame:SetChecked(true);
        else
            frame:SetChecked(false);
        end
    end)
-- End CheckButton enable Priest

-- =====

-- CheckButton enable Rogue
btnSayKarmaRogueEnable = CreateFrame("CheckButton", "btnSayKarmaRogueEnable_GlobalName", SayKarmaSettings.childpanel1, "ChatConfigCheckButtonTemplate");

-- text
btnSayKarmaRogueEnable_GlobalNameText:SetText("Enable Rogue detection");

-- position
btnSayKarmaRogueEnable:SetPoint("TOPLEFT", 20, -375);

-- tooltip, mouseOver
btnSayKarmaRogueEnable.tooltip = "Enable or disable spells\' detection from Rogue";

-- checkButton clicked
btnSayKarmaRogueEnable:SetScript("OnClick", 
  function()
    if (SayKarmaPrefs['RogueEnable'] == "yes") then
        SayKarmaFunctionRogueDisable();
    else
        SayKarmaFunctionRogueEnable();
    end
  end
);

-- init position button (true/false)
btnSayKarmaRogueEnable:SetScript("OnShow", function(frame)
        if (SayKarmaPrefs['RogueEnable'] == "yes") then
            frame:SetChecked(true);
        else
            frame:SetChecked(false);
        end
    end)
-- End CheckButton enable Rogue

-- =====

-- CheckButton enable Shaman
btnSayKarmaShamanEnable = CreateFrame("CheckButton", "btnSayKarmaShamanEnable_GlobalName", SayKarmaSettings.childpanel1, "ChatConfigCheckButtonTemplate");

-- text
btnSayKarmaShamanEnable_GlobalNameText:SetText("Enable Shaman detection");

-- position
btnSayKarmaShamanEnable:SetPoint("TOPLEFT", 20, -400);

-- tooltip, mouseOver
btnSayKarmaShamanEnable.tooltip = "Enable or disable spells\' detection from Shaman";

-- checkButton clicked
btnSayKarmaShamanEnable:SetScript("OnClick", 
  function()
    if (SayKarmaPrefs['ShamanEnable'] == "yes") then
        SayKarmaFunctionShamanDisable();
    else
        SayKarmaFunctionShamanEnable();
    end
  end
);

-- init position button (true/false)
btnSayKarmaShamanEnable:SetScript("OnShow", function(frame)
        if (SayKarmaPrefs['ShamanEnable'] == "yes") then
            frame:SetChecked(true);
        else
            frame:SetChecked(false);
        end
    end)
-- End CheckButton enable Shaman

-- =====

-- CheckButton enable Warlock
btnSayKarmaWarlockEnable = CreateFrame("CheckButton", "btnSayKarmaWarlockEnable_GlobalName", SayKarmaSettings.childpanel1, "ChatConfigCheckButtonTemplate");

-- text
btnSayKarmaWarlockEnable_GlobalNameText:SetText("Enable Warlock detection");

-- position
btnSayKarmaWarlockEnable:SetPoint("TOPLEFT", 20, -425);

-- tooltip, mouseOver
btnSayKarmaWarlockEnable.tooltip = "Enable or disable spells\' detection from Warlock";

-- checkButton clicked
btnSayKarmaWarlockEnable:SetScript("OnClick", 
  function()
    if (SayKarmaPrefs['WarlockEnable'] == "yes") then
        SayKarmaFunctionWarlockDisable();
    else
        SayKarmaFunctionWarlockEnable();
    end
  end
);

-- init position button (true/false)
btnSayKarmaWarlockEnable:SetScript("OnShow", function(frame)
        if (SayKarmaPrefs['WarlockEnable'] == "yes") then
            frame:SetChecked(true);
        else
            frame:SetChecked(false);
        end
    end)
-- End CheckButton enable Warlock

-- =====

-- CheckButton enable Warrior
btnSayKarmaWarriorEnable = CreateFrame("CheckButton", "btnSayKarmaWarriorEnable_GlobalName", SayKarmaSettings.childpanel1, "ChatConfigCheckButtonTemplate");

-- text
btnSayKarmaWarriorEnable_GlobalNameText:SetText("Enable Warrior detection");

-- position
btnSayKarmaWarriorEnable:SetPoint("TOPLEFT", 20, -450);

-- tooltip, mouseOver
btnSayKarmaWarriorEnable.tooltip = "Enable or disable spells\' detection from Warrior";

-- checkButton clicked
btnSayKarmaWarriorEnable:SetScript("OnClick", 
  function()
    if (SayKarmaPrefs['WarriorEnable'] == "yes") then
        SayKarmaFunctionWarriorDisable();
    else
        SayKarmaFunctionWarriorEnable();
    end
  end
);

-- init position button (true/false)
btnSayKarmaWarriorEnable:SetScript("OnShow", function(frame)
        if (SayKarmaPrefs['WarriorEnable'] == "yes") then
            frame:SetChecked(true);
        else
            frame:SetChecked(false);
        end
    end)
-- End CheckButton enable Warrior

-- End Contents MainPanel ==============================

-- Add the child to the Interface Options
InterfaceOptions_AddCategory(SayKarmaSettings.childpanel1);

-- =====================================================
-- DEATHKNIGHT PANEL

SayKarmaSettings.childpanelDeathKnight = CreateFrame( "Frame", "SayKarmaOptionPanelChild", SayKarmaSettings.panel);
SayKarmaSettings.childpanelDeathKnight.name = "DeathKnight";
SayKarmaSettings.childpanelDeathKnight.parent = SayKarmaSettings.panel.name;

-- Contents DeathKnightPanel

-- End Contents DeathKnightPanel

-- Add the child to the Interface Options
InterfaceOptions_AddCategory(SayKarmaSettings.childpanelDeathKnight);

-- =====================================================
-- DRUID PANEL

SayKarmaSettings.childpanelDruid = CreateFrame( "Frame", "SayKarmaOptionPanelChild", SayKarmaSettings.panel);
SayKarmaSettings.childpanelDruid.name = "Druid";
SayKarmaSettings.childpanelDruid.parent = SayKarmaSettings.panel.name;

-- Contents DruidPanel

-- End Contents DruidPanel

-- Add the child to the Interface Options
InterfaceOptions_AddCategory(SayKarmaSettings.childpanelDruid);

-- =====================================================
-- HUNTER PANEL

SayKarmaSettings.childpanelHunter = CreateFrame( "Frame", "SayKarmaOptionPanelChild", SayKarmaSettings.panel);
SayKarmaSettings.childpanelHunter.name = "Hunter";
SayKarmaSettings.childpanelHunter.parent = SayKarmaSettings.panel.name;

-- Contents HunterPanel

-- End Contents HunterPanel

-- Add the child to the Interface Options
InterfaceOptions_AddCategory(SayKarmaSettings.childpanelHunter);

-- =====================================================
-- MAGE PANEL

SayKarmaSettings.childpanelMage = CreateFrame( "Frame", "SayKarmaOptionPanelChild", SayKarmaSettings.panel);
SayKarmaSettings.childpanelMage.name = "Mage";
SayKarmaSettings.childpanelMage.parent = SayKarmaSettings.panel.name;

-- Contents MagePanel

-- End Contents MagePanel

-- Add the child to the Interface Options
InterfaceOptions_AddCategory(SayKarmaSettings.childpanelMage);

-- =====================================================
-- MONK PANEL

SayKarmaSettings.childpanelMonk = CreateFrame( "Frame", "SayKarmaOptionPanelChild", SayKarmaSettings.panel);
SayKarmaSettings.childpanelMonk.name = "Monk";
SayKarmaSettings.childpanelMonk.parent = SayKarmaSettings.panel.name;

-- Contents MonkPanel

-- End Contents MonkPanel

-- Add the child to the Interface Options
InterfaceOptions_AddCategory(SayKarmaSettings.childpanelMonk);

-- =====================================================
-- PALADIN PANEL

SayKarmaSettings.childpanelPaladin = CreateFrame( "Frame", "SayKarmaOptionPanelChild", SayKarmaSettings.panel);
SayKarmaSettings.childpanelPaladin.name = "Paladin";
SayKarmaSettings.childpanelPaladin.parent = SayKarmaSettings.panel.name;

-- Contents PaladinPanel

-- End Contents PaladinPanel

-- Add the child to the Interface Options
InterfaceOptions_AddCategory(SayKarmaSettings.childpanelPaladin);

-- =====================================================
-- PRIEST PANEL

SayKarmaSettings.childpanelPriest = CreateFrame( "Frame", "SayKarmaOptionPanelChild", SayKarmaSettings.panel);
SayKarmaSettings.childpanelPriest.name = "Priest";
SayKarmaSettings.childpanelPriest.parent = SayKarmaSettings.panel.name;

-- Contents PriestPanel

-- End Contents PriestPanel

-- Add the child to the Interface Options
InterfaceOptions_AddCategory(SayKarmaSettings.childpanelPriest);

-- =====================================================
-- PRIEST ROGUE

SayKarmaSettings.childpanelRogue = CreateFrame( "Frame", "SayKarmaOptionPanelChild", SayKarmaSettings.panel);
SayKarmaSettings.childpanelRogue.name = "Rogue";
SayKarmaSettings.childpanelRogue.parent = SayKarmaSettings.panel.name;

-- Contents RoguePanel

-- End Contents RoguePanel

-- Add the child to the Interface Options
InterfaceOptions_AddCategory(SayKarmaSettings.childpanelRogue);

-- =====================================================
